unit main;
(*
* WiXDrip - Directory Rip for WiX
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*)

(*
Uses TDosCommand.... I have added this to line 344 (or v2.0 420)... to ensure other languages get processed correctly.

        ///////// VB Sep 22, 2007
        //pBuf^[bread] := #0;    // Terminate
        //OemToChar(pBuf^,pBuf^);  // OemToAnsi access violates!!
        OemToCharBuff(pBuf^, pBuf^, bread);   // !! This is the right one
        ////////

*)


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,
  ApplicationWorkUnit,
  CalcWorkUnit,
  FileWorkUnit,
  DOSCommand,
  ExtCtrls, ComCtrls, Menus;

type
  TGuidEx = class
    //Creates and returns a new globally unique identifier
    class function NewGuid : TGuid;
    //sometimes we need to have an "empty" value, like NULL
    class function EmptyGuid : TGuid;
    //Checks whether a Guid is EmptyGuid
    class function IsEmptyGuid(Guid : TGuid) : boolean;
    //Convert to string
    class function ToString(Guid : TGuid) : string;
    //convert to quoted string
    class function ToQuotedString(Guid : TGuid) : string;
    //return a GUID from string
    class function FromString(Value : string) : TGuid;
    //Indicates whether two TGUID values are the same
    class function EqualGuids(Guid1, Guid2 : TGuid) : boolean;
  end;

  TDripForm = class(TForm)
    DosCommand1: TDosCommand;
    PanelTopSettings: TPanel;
    Label2: TLabel;
    EditWXSPathFile: TEdit;
    Label3: TLabel;
    EditRipBasePath: TEdit;
    PanelTallowList: TPanel;
    DirPath: TMemo;
    Label1: TLabel;
    Label4: TLabel;
    ButtonLoadBasePathsToFragment: TButton;
    ButtonTallow: TButton;
    PanelProgress: TPanel;
    Label5: TLabel;
    MemoTallow: TMemo;
    Label7: TLabel;
    Edit1: TEdit;
    EditTallow: TEdit;
    Label8: TLabel;
    StatusBar1: TStatusBar;
    PanelHolder: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Splitter1: TSplitter;
    Label6: TLabel;
    EditFreqPrepend: TEdit;
    Label9: TLabel;
    UICheckBox: TCheckBox;
    N1: TMenuItem;
    ReadMe1: TMenuItem;
    procedure DosCommand1NewLine(Sender: TObject; NewLine: String;
      OutputType: TOutputType);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditFilePathChange(Sender: TObject);
    procedure EditFileChange(Sender: TObject);
    procedure ButtonTallowClick(Sender: TObject);
    procedure ButtonLoadBasePathsToFragmentClick(Sender: TObject);
    function ProcessLine(pLine: String): String;
    procedure FormDestroy(Sender: TObject);
    procedure DosCommand1Terminated(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure EditFreqPrependChange(Sender: TObject);
    procedure ReadMe1Click(Sender: TObject);
  private
    function GUID: String;
    procedure DripTallow;
    procedure DefaultTallowCommand;
    { Private declarations }
  public
    { Public declarations }
  end;

const
// Standard colours etc
/////////////////////////////////////
{$I ConstStandardInclude.pas}
/////////////////////////////////////

var
  DripForm: TDripForm;

  GlobFileName : String;
  GlobDone     : Boolean;
  GlobComps    : TStringList;
  GlobCandle   : String;
  GlobLight    : String;


implementation

{$R *.dfm}
{$WARN UNIT_PLATFORM OFF}
{$R manifest.res}  // For use with Pretty XP graphics

class function TGuidEx.EmptyGuid: TGuid;
begin
  result := FromString('{00000000-0000-0000-0000-000000000000}');
end;

class function TGuidEx.EqualGuids(Guid1, Guid2: TGuid): boolean;
begin
  result := IsEqualGUID(Guid1, Guid2);
end;

class function TGuidEx.FromString(Value: string): TGuid;
begin
  result := StringToGuid(Value);
end;

class function TGuidEx.IsEmptyGuid(Guid : TGuid): boolean;
begin
  result := EqualGuids(Guid,EmptyGuid);
end;

class function TGuidEx.NewGuid: TGuid;
var
  Guid : TGuid;
begin
  CreateGUID(Guid);
  Result := Guid;
end;

class function TGuidEx.ToQuotedString(Guid: TGuid): string;
begin
  result := QuotedStr(ToString(Guid));
end;

class function TGuidEx.ToString(Guid: TGuid): string;
begin
  result := GuidToString(Guid);
end;

procedure TDripForm.FormCreate(Sender: TObject);
begin
     // DoubleBuffer and change general system defaults, look and feel
     AdjustApplicationToStandards(Self);
     // Load form locations and grid column settings
     WinLocationsCreate(Application.ExeName, Self);

     // Line things up
     PanelProgress.Align   := alBottom;
     PanelTallowList.Align := alClient;
     PanelProgress.Align   := alClient;

     GlobComps  := TStringList.Create;

     // Setup the defaults
     DefaultTallowCommand;

     // Load values from the reg
     EditWXSPathFile.Text := WinSettingRead(Application.ExeName, DripForm, 'EditWXSPathFile');
     EditRipBasePath.Text := WinSettingRead(Application.ExeName, DripForm, 'EditRipBasePath');
     EditFreqPrepend.Text := WinSettingRead(Application.ExeName, DripForm, 'EditFreqPrepend');
     UICheckBox.Checked   := (WinSettingRead(Application.ExeName, DripForm, 'UICheckBox') = 'Yes');

     // Set some deafults if nothing
     if  (EditWXSPathFile.Text = '') then EditWXSPathFile.Text := 'c:\Company\Wix\ProductInstall.wxs';
     // E:\engenic\Wix\TeleFlowTest.wxs
     //"c:\Company\Wix\ProductInstall.wxs"

     if  (EditRipBasePath.Text = '') then EditRipBasePath.Text := 'c:\Company\Wix\SourceDir';
     // E:\engenic\Wix\SourceDir\PFiles\TeleFlow
     //"c:\Company\Wix\SourceDir"

     if  (EditFreqPrepend.Text = '') then EditFreqPrepend.Text := 'fragment_';
end;

procedure TDripForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     WinSettingWrite(Application.ExeName, DripForm, 'EditWXSPathFile', EditWXSPathFile.Text);
     WinSettingWrite(Application.ExeName, DripForm, 'EditRipBasePath', EditRipBasePath.Text);
     WinSettingWrite(Application.ExeName, DripForm, 'EditFreqPrepend', EditFreqPrepend.Text);
     WinSettingWrite(Application.ExeName, DripForm, 'UICheckBox', iff(UICheckBox.Checked,'Yes','No'));

     // Save form locations and grid column settings
     WinLocationsClose(Application.ExeName, Self);
end;



procedure TDripForm.FormDestroy(Sender: TObject);
begin
     GlobComps.Free;
end;

// Close
procedure TDripForm.Exit1Click(Sender: TObject);
begin
     Close;
end;


// Give the users some ability to find us
procedure TDripForm.About1Click(Sender: TObject);
var
   mVer : String;
begin
     mVer := GetVersionInfo(application.ExeName);
     AppMessageDlg('Drip (for WiX) v: '+mVer+cCrLf+
                   'http://www.engenic.com ', mtInformation,
                   [mbOk], 0, color);
end;



function TDripForm.GUID: String;
begin
     result := TGuidEx.ToString(TGuidEx.NewGuid);
end;


procedure TDripForm.EditFilePathChange(Sender: TObject);
begin
     if DirectoryExists((Sender as TEdit).Text) then
     begin
          (Sender as TEdit).Color := clWindow;
     end
     else
     begin
          (Sender as TEdit).Color := clYellow;
     end
end;

procedure TDripForm.EditFileChange(Sender: TObject);
begin
     if FileExists((Sender as TEdit).Text) then
     begin
          (Sender as TEdit).Color := clWindow;
     end
     else
     begin
          (Sender as TEdit).Color := clEngOrange;
     end
end;

procedure TDripForm.EditFreqPrependChange(Sender: TObject);
begin
     if StripOutNonNamingChars((Sender as TEdit).Text) = (Sender as TEdit).Text then
     begin
          (Sender as TEdit).Color := clWindow;
     end
     else
     begin
          (Sender as TEdit).Color := clEngOrange;
     end
end;


procedure TDripForm.ButtonLoadBasePathsToFragmentClick(Sender: TObject);
var
   mFileName: String;

   mLoop: integer;
begin
     ChDir(ExtractFileDir(EditWXSPathFile.Text));

     DefaultTallowCommand;

     //ScanDirMask('*.Wav');
     ScanListSubDirectories(EditRipBasePath.Text);
     // ... or ScanDirectory
     ScanDirTop;

     // build the file list
     DirPath.Clear;
     for mLoop := 0 to ScanDirCount - 1 do
     begin
          mFileName    := ScanDirFetchNext;
          DirPath.Lines.Add(mFileName);
     end;
end;


// Default Tallow
procedure TDripForm.DefaultTallowCommand;
begin
     EditTallow.Text := 'tallow.exe -nologo -d [each_above_path] > [each_above_name.wxs]';
end;


procedure TDripForm.ButtonTallowClick(Sender: TObject);
begin
     if AppMessageDlg('This process will "Drip Tallow" to create the Fragments which can be included'+cCrLf+
                      'in your WiX project.  Consider backing up everything first.  Continue?',
                       mtConfirmation, [mbYes, mbNo], 0, Color) = mrYes then
     begin
          ButtonLoadBasePathsToFragment.Enabled := False;
          ButtonTallow.Enabled                  := False;

          GlobComps.Clear;

          try
             DripTallow;
          finally
             ButtonLoadBasePathsToFragment.Enabled := True;
             ButtonTallow.Enabled                  := True;
          end;
     end;
end;

// Performs all the work.
procedure TDripForm.DripTallow;
var
   mFile    : TStringList;
   mCommand : String;
   mFileStr : String;
   mLoop    : Integer;
   mPos     : Integer;
   mPause   : Integer;
begin
     mFile := TStringList.Create;
     try
        GlobCandle  := 'candle.exe ';
        GlobLight   := 'light.exe -out '+'Install.msi'+' ';

        // Include standard UI?
        if UICheckBox.Checked then
        begin
             GlobCandle := GlobCandle + 'UI.wxs ';
             GlobLight  := GlobLight  + 'UI.wixobj ';
        end;


        for mLoop := 0 to DirPath.Lines.Count - 1 do
        begin
             // Only process directories that exist
             if DirectoryExists(DirPath.Lines[mLoop]) then
             begin
                  GlobDone    := False;

                  MemoTallow.Clear;
                  //MemoTallow.Lines.Add('<?xml version="1.0" encoding="utf-8"?>');
                  MemoTallow.Lines.Add('<?xml version="1.0" encoding="windows-1252"?>'); // Works with multilanguage

                  GlobFileName := ChangeFileExt(ExtractFileName(DirPath.Lines[mLoop]), '');

                  mCommand := EditTallow.Text;
                  mCommand := StringReplaceAll(mCommand, '[each_above_path]', DirPath.Lines[mLoop]);

                  mPos := Pos('>', mCommand);
                  if (mPos > 1) then
                  begin
                       mCommand := Copy(mCommand,1,mPos-1);
                  end;


                  // Method 2
                 // mFile.Clear;
                 // mFile.Add(mCommand);
                //  mFile.SaveToFile('DripTallow.cmd');
                 // Dos2Win('DripTallow.bat', Memo1);
                 // Memo1.Lines.Add(mCommand);
                 // RunDosInMemo(mCommand,  Memo1);

                  // Method 1 - Failed because it didnt do the OemToAnsi thing correctly with the charset
                  DosCommand1.CommandLine := mCommand;
                  DosCommand1.Execute;
                  // Wait until it is done....
                  while (GlobDone = False) do
                  begin
                       sleep(10)  ;
                       application.ProcessMessages;
                  end;

                  // Wait another second
                  for mPause := 1 to 100 do
                  begin
                       sleep(10)  ;
                       application.ProcessMessages;
                  end;


                  // Save it for user
                  mFileStr := IncludeTrailingPathDelimiter(Trim(ExtractFilePath(EditWXSPathFile.Text)))+EditFreqPrepend.Text+GlobFileName+'.wxs';
                  MemoTallow.Lines.SaveToFile(mFileStr);

                  // Candle
                  GlobCandle := GlobCandle + ExtractFileNameNoPath(mFileStr) + ' ';
                  GlobLight  := GlobLight + ChangeFileExt(ExtractFileNameNoPath(mFileStr), '.wixobj') + ' ';

                  // Set it again...
                  GlobDone    := False;
                  sleep(1000);
                  // and ... GO
             end;
        end;

        // Add these to your Wix Project
        MemoTallow.Clear;
        MemoTallow.Lines.Add('<!-- Add these Component definitions to your Wix Project in the Features sections... ');
        MemoTallow.Lines.AddStrings( GlobComps );
        MemoTallow.Lines.Add('-->');
        MemoTallow.Lines.Add(' ');
        MemoTallow.Lines.Add('<!-- Your new Candle/Light command batch should include -->');
        MemoTallow.Lines.Add('<!--');
        MemoTallow.Lines.Add('path=%path%;C:\Program Files\InstallAware\WiXAware\WixToolset');
        MemoTallow.Lines.Add(' ');
        MemoTallow.Lines.Add('cd '+ExtractFilePath(EditWXSPathFile.Text));
        MemoTallow.Lines.Add(' ');
        MemoTallow.Lines.Add(GlobCandle+' '+ExtractFileName(EditWXSPathFile.Text));
        MemoTallow.Lines.Add(' ');
        MemoTallow.Lines.Add(GlobLight+' '+ChangeFileExt(ExtractFileName(EditWXSPathFile.Text), '.wixobj'));
        MemoTallow.Lines.Add('-->');
     finally
        mFile.Free;
     end;

     // Finally
     AppMessageDlg('The "Drip Tallow" process has completed with '+IntToStr(GlobComps.Count)+' Components discovered.'+cCrLf+
                   'Review the bottom memo field for any Components you need to add to your Project.'+cCrLf+
                   'The commands to build a batch file to regenerate the project are below the Components List.'+cCrLf+
                   'You can run this process again and again, but remember your GUIDs will update each time.',
                   mtInformation, [mbOk], 0, Color);
end;

procedure TDripForm.DosCommand1NewLine(Sender: TObject; NewLine: String;
  OutputType: TOutputType);
begin
     if OutputType = otEntireLine then
     begin
          MemoTallow.Lines.Add(ProcessLine(newLine));
     end;
     sleep(5);
     application.processmessages;
end;


(*
Tallow -> Drip  // Directory RIP .. Drips Tallow
[x] - Change: "PUT-GUID-HERE" to "{a real GUID}"
   [_] - One time only... later, include a method to refresh directory and keep GUIDs
[x] - Change: '<DirectoryRef Id="TARGETDIR">'     to   <DirectoryRef Id="INSTALLDIR">
[x] - Change: '<Directory Id="'  to '<Directory Id="[[BaseDirName]]'
[x] - Change: '<Component Id="'  to '<Component Id="[[BaseDirName]]'
[x] - Source get current path, and remove futher reference Remove Path:  'E:\enGenic\Wix\'
[x] - Grep out component list | Put it in some order
*)
function TDripForm.ProcessLine(pLine: String): String;
const
   cGuidRequest  =  'Guid="PUT-GUID-HERE"';
   cTargetDir    =  '<DirectoryRef Id="TARGETDIR">';
   cDirID        =  '<Directory Id="';
   cFileID       =  '<File Id="';
   cCompID       =  '<Component Id="';
var
   mField      : String;
   mRecord     : String;
   mBasePath   : String;
   mCompName   : String;
begin
     mRecord := pLine;

     // Gather values
     mCompName   := GlobFileName;
     mBasePath   := IncludeTrailingPathDelimiter(Trim(ExtractFilePath(EditWXSPathFile.Text)));


     // Create GUID
     if (Pos(cGuidRequest,mRecord) > 0) then
     begin
          mField  := 'Guid="'+GUID+'"';
          mRecord := StringReplaceAll(mRecord, cGuidRequest, mField);
     end;

     // Replace INSTALL dir
     if (Pos(cTargetDir,mRecord) > 0) then
     begin
          mField  := '<DirectoryRef Id="INSTALLDIR">';
          mRecord := StringReplaceAll(mRecord, cTargetDir, mField);
     end;

     // Remove Source direct path ( Make a relative path )
     if (Pos(lowercase(mBasePath),lowercase(mRecord)) > 0) then
     begin
          mField  := '';
          // Replace the occurance (should be at the start of the string)
          mRecord := StringReplace(mRecord, mBasePath, mField, [rfIgnoreCase]);
     end;

     // Change dir path to make unique
     if (Pos(cDirID,mRecord) > 0) then
     begin
          mField  := cDirID + mCompName +'_';
          mRecord := StringReplaceAll(mRecord, cDirID, mField);
     end;

     // Change file name to make unique
     if (Pos(cFileID,mRecord) > 0) then
     begin
          mField  := cFileID + mCompName +'_';
          mRecord := StringReplaceAll(mRecord, cFileID, mField);
     end;

     // Change comp path to make referencace.
     if (Pos(cCompID,mRecord) > 0) then
     begin
          mField  := cCompID + mCompName +'_';
          mRecord := StringReplaceAll(mRecord, cCompID, mField);

          // Gather the name of the comp
          mField  := '      <ComponentRef Id="'+XMLGetAttributeValue('Id', mRecord)+'" />';
          GlobComps.Add(mField);
     end;

     result := mRecord;
end;


procedure TDripForm.DosCommand1Terminated(Sender: TObject);
begin
     // Put up the list of components now
     GlobDone := True;
end;

procedure TDripForm.ReadMe1Click(Sender: TObject);
var
   mReadMe: String;
begin
     mReadMe := ChangeFileExt(Application.Exename, '.rtf');
     ExecuteAssociatedFile(mReadMe, '', '', SW_SHOW);
end;

end.
